//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  `悷鎞̒[_̌`(bv)ɂ
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N0524 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, GDIPOBJ, GDIPAPI, GDIPUTIL, Spin, ExtDlgs;

type
  TMyPanel = class(TPanel)
  private
    FArrowWidth  : Integer;
    FArrowHeight : Integer;
    procedure SetFArrowWidth(const Value: Integer);
    procedure SetFArrowHeight(const Value: Integer);
  protected
    procedure Paint; override;
    procedure DrawImage(ACanvas: TCanvas);
  public
    constructor Create(AOwner: TComponent); override;
    property ArrowWidth  : Integer read FArrowWidth  write SetFArrowWidth;
    property ArrowHeight : Integer read FArrowHeight write SetFArrowHeight;
  end;

  TForm1 = class(TForm)
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    OpenPictureDialog1: TOpenPictureDialog;
    procedure FormCreate(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
  private
    { Private 錾 }
    MyPanel : TMyPanel;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Self.Caption := 'GDI+  ';

  //TMyPanel𐶐Ĕzu
  MyPanel := TMyPanel.Create(Self);
  with MyPanel do begin
    Parent  := Self;
    Left    := 5;
    Top     := 35;
    Width   := Self.ClientWidth  - 10;
    Height  := Self.ClientHeight - Top - 5;
    Anchors := [akLeft, akTop, akRight, akBottom];
    Color   := clWhite;
    ParentBackground := False;
    DoubleBuffered   := True;
  end;

  SpinEdit1.Value := MyPanel.ArrowWidth;
  SpinEdit2.Value := MyPanel.ArrowHeight;
end;

//=============================================================================
//  SpinEdit1OnChangeCxg
//  TMyPanelArrowWidthvpeBݒ
//=============================================================================
procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  MyPanel.ArrowWidth := SpinEdit1.Value;
end;

//=============================================================================
//  SpinEdit2OnChangeCxg
//  TMyPanelArrowHeightvpeBݒ
//=============================================================================
procedure TForm1.SpinEdit2Change(Sender: TObject);
begin
  MyPanel.ArrowHeight := SpinEdit2.Value;
end;

{ TMyPanel }

//-----------------------------------------------------------------------------
//  TMyPanel̃RgN^
//-----------------------------------------------------------------------------
constructor TMyPanel.Create(AOwner: TComponent);
begin
  inherited;

  FArrowWidth  := 8;
  FArrowHeight := 8;
end;

//-----------------------------------------------------------------------------
//  TMyPanelArrowWidthvpeBݒp\bh
//  ̕(Op`̒ӂ̒)̐ݒ
//  ̒l͐̑̔{l
//-----------------------------------------------------------------------------
procedure TMyPanel.SetFArrowWidth(const Value: Integer);
begin
  if FArrowWidth <> Value then begin
    FArrowWidth := Value;
    Invalidate;
  end;
end;

//-----------------------------------------------------------------------------
//  TMyPanelArrowHeightvpeBݒp\bh
//  ̍(Op`̍)̐ݒ
//  ̒l͐̑̔{l
//-----------------------------------------------------------------------------
procedure TMyPanel.SetFArrowHeight(const Value: Integer);
begin
  if FArrowHeight <> Value then begin
    FArrowHeight := Value;
    Invalidate;
  end;
end;

//-----------------------------------------------------------------------------
//  ۂ̕`R[h
//  `悷鎞̒[_̌`(bv)ɂ
//
//  ACanvas : `TCanas
//-----------------------------------------------------------------------------
procedure TMyPanel.DrawImage(ACanvas: TCanvas);
var
  LGPGraphics   : TGPGraphics;
  LGPPen        : TGPPen;
  LGPStartArrow : TGPAdjustableArrowCap;
  LGPEndArrow   : TGPAdjustableArrowCap;
  LLineLength   : Integer;
  LPosX         : Integer;
  LPosY         : Integer;
begin
  //̒ƕ`JnXWl
  LLineLength := 280;
  LPosX       := 20;

  //n_ƏI[̖̃IuWFNg𐶐
  //Ō̈False͓̎hׂȂ
  LGPStartArrow := TGPAdjustableArrowCap.Create(FArrowHeight, FArrowWidth, False);
  LGPEndArrow   := TGPAdjustableArrowCap.Create(FArrowHeight, FArrowWidth, True);

  //`悷邽߂ɎgpTGPPen̐
  //[_`̏Zbg
  LGPPen := TGPPen.Create(MakeColor(255, 0, 0, 0));
  LGPPen.SetCustomStartCap(LGPStartArrow);
  LGPPen.SetCustomEndCap(LGPEndArrow);

  //`w肵TGPGraphics
  LGPGraphics := TGPGraphics.Create(ACanvas.Handle);

  //̑w肵ĕ`
  LPosY := 50;
  LGPPen.SetWidth(5.0);
  LGPGraphics.DrawLine(LGPPen, LPosX, LPosY, LPosX + LLineLength, LPosY);

  //̑ύXĕ`
  LPosY := 150;
  LGPPen.SetWidth(10.0);
  LGPGraphics.DrawLine(LGPPen, LPosX, LPosY, LPosX + LLineLength, LPosY);

  LGPStartArrow.Free;
  LGPEndArrow.Free;
  LGPPen.Free;
  LGPGraphics.Free;
end;

//-----------------------------------------------------------------------------
//  TMyPanelPaint\bh
//  CanvasTImage.CanvasɂTImageւ̕`ƂȂ
//-----------------------------------------------------------------------------
procedure TMyPanel.Paint;
begin
  inherited;
  DrawImage(Canvas);
end;

end.
